#!/usr/bin/perl

use CGI;
use XML::RSS;
use Net::POP3;

my $cgi = new CGI();
my $num = ( $cgi->param('n') ? $cgi->param('n') * -1 : -20 );
my $user = $cgi->param('u') || $cgi->param('user') || 'phytar';
my $pass = $cgi->param('p') || $cgi->param('pass');
my $host = $cgi->param('h') || $cgi->param('host') || 'mail.csh.rit.edu';
my $rss = new XML::RSS( version => '1.0' );
my $pop = new Net::POP3( $cgi->param('host') );

$rss->channel(
  title => "POP3 Mail for $user\@$host",
  description => "POP3 Mail for $user\@$host",
  link => 'http://csh.rit.edu/~phytar/',
  dc => { creator => 'John Resig phytar\@csh.rit.edu' }
);

print "Content-type: text/rss\n\n";
if ( $pop->login( $user, $pass ) ) {
  my $msgs = $pop->list;
  for ( my $i = -1; $i >= $num; $i-- ) {
    my $msg = join( '', @{$pop->get( (reverse sort {$b<=>$a} keys %$msgs)[$i] )} );

    # Get the message content
    $msg =~ /From: (.*)/i;
    my $creator = $1;
    $creator =~ s/"//g;
    $msg =~ /Subject: (.*)/i;
    my $title = $1;
    $title =~ s/"//g;
    $msg =~ /\n\n(.*)$/is;
    my $description = $1;

    # Attempt to find the plain text version
    if ( $description =~ /\n--/s ) {
      $description =~ /text\/plain.*?\n\n(.*?)\n--/is;
      $description = $1;
      $description =~ s/<[^>]*>//gs;
      $description =~ s/\n/<br\/>/gs;
    }

    # Prune out all the nastiness
    $description =~ s/\s*=[A-Z0-9]{2}\s*//g;
    $description =~ s/[ \t][ \t]+/ /gs;
    $description =~ s/\n{3,}/\n\n/gs;
    $description =~ s/\c@//gs;
    $description =~ s/\s*$//gs;
    $description = "<![CDATA[$description]]>";

    # Add to the RSS Feed
    $rss->add_item( title => $title, description => $description,
      dc => { creator => $creator },
      link => $title );
  }
}

print $rss->as_string;
$pop->quit;
